package krbzsq.surge.html;

import java.util.ArrayList;
import java.util.List;

public class Element {
    private String tag;
    private String inner;
    private List<String[]> attrs = new ArrayList<>();

    public static Element init(String tag, String inner) {
        return new Element(tag, inner);
    }

    public static Element init(String tag) {
        return new Element(tag);
    }

    private Element(String tag) {
        this.tag = tag.replaceAll("\\s+","_");
        this.inner = null;
    }

    private Element(String tag, String inner) {
        this.tag = tag;
        this.inner = inner;
    }

    public Element attr(String key, String val) {
        attrs.add(new String []{key,val});
        return this;
    }

    @Override
    public String toString() {
        if(tag == null) {
            return "";
        }
        StringBuilder bldr = new StringBuilder();
        bldr.append("<").append(tag);
        if(attrs.size() > 0) {
            bldr.append(" ");
            for(int i = 0; i < attrs.size(); i++) {
                String[] att = attrs.get(i);
                bldr.append(att[0]).append("=\"").append(att[1]).append("\"");
                if(i != attrs.size()-1) {
                    bldr.append(" ");
                }
            }
        }
        if(inner == null) {
            bldr.append("/>\n");
        } else {
            bldr.append(">").append(inner).append("</").append(tag).append(">\n");
        }
        return bldr.toString();
    }
}
