package krbzsq.surge.net;

import java.util.ArrayList;
import java.util.List;

public class HttpRequest {
    private HttpRequestType type;
    private String path;
    private List<HttpHeader> headers;
    private List<HttpVariable> variables = new ArrayList<>();

    public HttpRequest(HttpRequestType type, String path, List<HttpHeader> headers) {
        this(type, path, headers, null);
    }

    public HttpRequest(HttpRequestType type, String path, List<HttpHeader> headers, List<HttpVariable> vars) {
        this.type = type;
        this.path = path;
        this.headers = headers;
        variables = vars;
    }

    public HttpRequestType getType() {
        return type;
    }

    public String getPath() {
        return path;
    }

    public List<HttpHeader> getHeaders() {
        return headers;
    }

    public List<HttpVariable> getVariables() {
        return variables;
    }
}
