package krbzsq.surge.net;

import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.ByteToMessageDecoder;
import krbzsq.surge.util.HTTP;

import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class HttpRequestDecoder extends ByteToMessageDecoder {

    @Override
    protected void decode(ChannelHandlerContext ctx, ByteBuf in, List<Object> objects) throws Exception {
        if (in.isReadable()) {
            String chunk = HTTP.readChunk(in).trim();
            String[] lines = chunk.split("\n");
            String reqLine = lines[0];
            String req = reqLine.substring(0, reqLine.indexOf(" "));
            String path = reqLine.substring(reqLine.indexOf(" ") + 1, reqLine.indexOf("HTTP/1.1") - 1);
            HttpRequestType type = HttpRequestType.valueOf(req);
            List<HttpHeader> headers = new ArrayList<>();
            Pattern pattern = Pattern.compile("([a-zA-Z].*): (.*?)\r\n");
            Matcher matcher = pattern.matcher(chunk);
            while (matcher.find()) {
                headers.add(new HttpHeader(matcher.group(1), matcher.group(2)));
            }
            if (type == HttpRequestType.POST) {
                String last = lines[lines.length - 1];
                String[] vars = last.split("&");
                List<HttpVariable> variables = new ArrayList<>();
                for (String var : vars) {
                    String[] se = var.split("=");
                    String key,val;
                    if(se.length == 1) {
                        val = "";
                    } else {
                        val = se[1];
                    }
                    if(se.length == 0) {
                        key = "";
                    } else {
                        key = se[0];
                    }
                    variables.add(new HttpVariable(HTTP.decode(key), HTTP.decode(val)));
                }
                objects.add(new HttpRequest(type, path, headers, variables));
                return;
            }
            objects.add(new HttpRequest(type, path, headers));
        }
    }
}
