package krbzsq.surge.net;

import java.util.ArrayList;
import java.util.List;

public class HttpResponse {
    private int status;
    private String data;
    private List<HttpHeader> headers = new ArrayList<HttpHeader>();

    public HttpResponse(int status, String data) {
        this.status = status;
        this.data = data;
        headers.add(new HttpHeader("Content-Type", "text/html"));
        headers.add(new HttpHeader("Content-Length", data.length()));
    }

    public HttpResponse(int status, String data, List<HttpHeader> headers) {
        this.status = status;
        this.data = data;
        this.headers = headers;
    }

    public int getStatus() {
        return status;
    }

    public String getData() {
        return data;
    }

    public List<HttpHeader> getHeaders() {
        return headers;
    }
}
