package krbzsq.surge.net;

import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.MessageToByteEncoder;
import krbzsq.surge.util.HTTP;

import java.util.ArrayList;
import java.util.List;

public class HttpResponseEncoder extends MessageToByteEncoder<HttpResponse> {
    @Override
    protected void encode(ChannelHandlerContext ctx, HttpResponse resp, ByteBuf out) throws Exception {
        List<String> lines = new ArrayList<>();
        lines.add("HTTP/1.1 " + resp.getStatus() + " " + HTTP.statusString(resp.getStatus()) + "\r\n");
        for(HttpHeader header : resp.getHeaders()) {
            lines.add(header.getKey() + ": " + header.getValue() + "\r\n");
        }
        lines.add("\r\n");
        for(String line : lines) {
            out.writeBytes(line.getBytes());
        }
        out.writeBytes(resp.getData().getBytes());
    }
}
