package krbzsq.surge.net;

import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.ChannelInboundHandlerAdapter;
import krbzsq.surge.Surge;
import krbzsq.surge.Session;
import krbzsq.surge.util.HTTP;
import krbzsq.surge.util.Route;
import krbzsq.surge.view.Page;

public class SurgeHandler extends ChannelInboundHandlerAdapter {
    private Surge surge;
    private Session session = new Session("test");

    public SurgeHandler(Surge surge) {
        this.surge = surge;
    }

    @Override
    public void channelRead(ChannelHandlerContext ctx, Object msg) throws Exception {
        if (msg instanceof HttpRequest) {
            HttpRequest r = (HttpRequest) msg;
            if (r.getPath() == null || r.getType() == null) {
                return;
            }
            Route route = surge.routes().get(r.getPath());
            Page page;
            int status = 200;
            if (route == null || route.getKey() == null || route.getPage() == null || route.getRules() == 0
                    || !HTTP.ruleCheck(r, route)) {
                page = surge.getErrorPage();
                status = 404;
            } else {
                page = route.getPage();
            }
            ctx.channel().writeAndFlush(page.doRespond(status, r, session));
        }
    }
}
