package krbzsq.surge.util;

import io.netty.buffer.ByteBuf;
import krbzsq.surge.net.HttpRequest;

import java.net.URLDecoder;

public class HTTP {

    public static String readChunk(ByteBuf in) {
        StringBuilder bldr = new StringBuilder();
        byte b;
        while (in.isReadable() && (b = in.readByte()) != '\0') {
            bldr.append((char) b);
        }
        return bldr.toString();
    }

    public static boolean ruleCheck(HttpRequest request, Route route) {
        int rules = route.getRules();
        boolean reqType = ((1<<request.getType().ordinal()) & rules) != 0;
        return reqType;
    }

    public static String statusString(int status) {
        switch (status) {
            case 200:
                return "OK";
            case 404:
                return "Not Found";
        }
        return null;
    }

    public static String decode(String in) {
        if(in == null || in.isEmpty()) {
            return "";
        }
        return URLDecoder.decode(in);
    }
}
