package krbzsq.surge.util;

import krbzsq.surge.net.HttpRequestType;
import krbzsq.surge.view.Page;

public class Route {
    public static final int GET = (1<< HttpRequestType.GET.ordinal());
    public static final int POST = (1<<HttpRequestType.POST.ordinal());
    private String key;
    private Page page;
    private int rules = 0;

    public Route(String key, Page page, int... rules) {
        this.key = key;
        this.page = page;
        if(rules == null || rules.length == 0) {
            this.rules |= GET;
            return;
        }
        for(int i : rules) {
            this.rules |= i;
        }
    }

    public String getKey() {
        return key;
    }

    public Page getPage() {
        return page;
    }

    public int getRules() {
        return rules;
    }
}
