package krbzsq.surge.view.template;

import krbzsq.surge.view.Page;
import krbzsq.surge.view.style.Stylesheet;
import krbzsq.surge.view.style.StylesheetCompiler;

public class DefaultTemplate implements Template {
    private Page page;

    public DefaultTemplate(Page page) {
        this.page = page;
    }

    @Override
    public String getTop() {
        StringBuilder bldr = new StringBuilder();
        bldr.append("<!DOCTYPE html>\n");
        bldr.append("<html>\n");
        bldr.append("<head>\n");
        bldr.append("<title>").append(page.getTitle()).append("</title>\n");
        if(page.getStylesheets().size() > 0) {
            for(Stylesheet sheet : page.getStylesheets()) {
                bldr.append("<style>\n");
                bldr.append(StylesheetCompiler.compile(sheet)).append("\n");
                bldr.append("</style>\n");
            }
        }
        bldr.append("</head>\n");
        bldr.append("<body>\n");
        return bldr.toString();
    }

    @Override
    public String getBottom() {
        StringBuilder bldr = new StringBuilder();
        bldr.append("</body>\n");
        bldr.append("</html>\n");
        return bldr.toString();
    }
}
